/**
 * Contact form
 */

// JS-File from the contact form of the highland template
// Modification by Florian Barth to match with restxq-Backend:
// error for email/name/message are stored in one object literal as key/valuepairs
// (original: nested literals for error and email/name/message)

$(document).ready(function() {
  $('#form_sendemail').submit(function() {
    $.ajax({
      url: 'http://localhost:8080/exist/restxq/api/form',
      type: 'POST',
      data: $('#form_sendemail').serialize(),
      contentType:'application/x-www-form-urlencoded',
      dataType: 'json',
      beforeSend: function (XMLHttpRequest) {
        $('#form_sendemail .has-error').removeClass('has-error');
        $('#form_sendemail .help-block').html('').hide();
        $('#form_message').removeClass('alert-success').html('');
      },
      success: function( json, textStatus ) {
        // if( json.error ) {
          // Error messages
          if( json.error_name ) {
            $('#form_sendemail input[name="name"]').parent().addClass('has-error');
            $('#form_sendemail input[name="name"]').next('.help-block').html( json.error_name ).slideDown();
          }
          if( json.error_email ) {
            $('#form_sendemail input[name="email"]').parent().addClass('has-error');
            $('#form_sendemail input[name="email"]').next('.help-block').html( json.error_email ).slideDown();
          }
          if( json.error_message ) {
            $('#form_sendemail textarea[name="message"]').parent().addClass('has-error');
            $('#form_sendemail textarea[name="message"]').next('.help-block').html( json.error_message ).slideDown();
          }
        //   if( json.error.recaptcha ) {
        //     $('#form-captcha').addClass('has-error');
        //     $('#form-captcha .help-block').html( json.error.recaptcha ).slideDown();
        //   }

        // }

        // Refresh Captcha
        // grecaptcha.reset();
        //
        if( json.success ) {
          $('#form_message').addClass('alert-success').html( json.success ).slideDown();
          
          setTimeout(function() {
            $('#form_message').slideUp("fast", function() {
              $(this).removeClass('alert-success').html('');
             });
          },4000);
          $('#form_sendemail').find('.form-control').val('');
        }
        
      },
      complete: function( XMLHttpRequest, textStatus ) {
        console.log( "complete" );
        //
      }
    });
    
    return false;
  });
});